OGRE: Ogre::StringInterface Class Reference - OGRE Documentation

Public Member Functions | Static Public Member Functions | Protected Member Functions | Private Attributes | Static Private Attributes

# Ogre::StringInterface Class Reference
[General]

Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers. More...

`#include <OgreStringInterface.h>`

Inheritance diagram for Ogre::StringInterface:
[legend]

List of all members.

## Public Member Functions
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Member Functions
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Private Attributes
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
ParamDictionary * | mParamDict
## Static Private Attributes
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.

Remarks:
  This class also holds a static map of class name to parameter dictionaries for each subclass to use. See ParamDictionary for details.
  In order to use this class, each subclass must call createParamDictionary in their constructors which will create a parameter dictionary for the class if it does not exist yet.

Definition at line 161 of file OgreStringInterface.h.

## Constructor & Destructor Documentation

Ogre::StringInterface::StringInterface | ( |  | ) |

Definition at line 205 of file OgreStringInterface.h.

virtual Ogre::StringInterface::~StringInterface | ( |  | ) | `[virtual]`

Virtual destructor, see Effective C++.

Definition at line 208 of file OgreStringInterface.h.

## Member Function Documentation

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and setParameter().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

## Member Data Documentation

ParamDictionary* Ogre::StringInterface::mParamDict`[private]`

Definition at line 171 of file OgreStringInterface.h.

String Ogre::StringInterface::mParamDictName`[private]`

Class name for this instance to be used as a lookup (must be initialised by subclasses).

Definition at line 170 of file OgreStringInterface.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, private]`

Dictionary of parameters.

Definition at line 167 of file OgreStringInterface.h.

The documentation for this class was generated from the following file:

- OgreStringInterface.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:02